Rev Author Line No. Line
3407 kakl 1 #!/usr/bin/env bash
2  
3 [[ $# -ne 1 ]] && echo "Usage: ./sync.sh /path/to/folder" && exit 1
4  
5 # Redirect stdout ( > ) into a named pipe ( >() ) running "tee"
6 exec > >(tee "$1"/logfile.txt)
7  
8 # Also redirect stderr
9 exec 2>&1
10  
3410 kakl 11 FREQUENCY=180
3407 kakl 12  
13 TIDYUP="$(pwd)/tidyup.sh"
14 RSYNC="$(pwd)/upload.sh"
15  
16 DEFAULT="\033[00m"
17 RED="\033[01;31m"
18 BLUE="\033[01;36m"
19  
20 function info() {
21 echo -en "$BLUE"; echo -n $1; echo -e "$DEFAULT"
22 }
23  
24 function error() {
25 echo -en "$RED"; echo -n $1; echo -e "$DEFAULT"
26 }
27  
28 function syncdir() {
29 EXIT=1
30 i=1
3410 kakl 31 # while [ $EXIT -ne 0 ]; do
3407 kakl 32 info "Trying to sync $1, try number $i"
33 "$RSYNC" "$1"
34 EXIT=$?
35 [ $EXIT -ne 0 ] && error "sync failed"
36 let i++
3410 kakl 37 # done
3407 kakl 38 return $EXIT
39 }
40  
41 # Sort files
42 # Mask
43 function tidyup() {
44 info "sorting $1"
45 "$TIDYUP" $1
46 if [ "$?" -ne 0 ]; then
47 error "sorting failed, please send logfile.txt to toxygen1@gmail.com"
48 return 1
49 fi
50 return 0
51 }
52  
53 # Test public key authentication
54 function sshtest() {
55 ./test.sh
56 if [ "$?" -eq 0 ]; then
57 info "Authentication works"
58 return 0
59 else
60 error "Authentication does not work"
61 return 1
62 fi
63 }
64  
65 # Check if we can connect, otherwise terminate
66 sshtest || exit 1
67  
68 # Change working directory
69 cd $1
70  
3410 kakl 71  
3407 kakl 72 # reset counter
73 HOURCOUNT=24
74  
75 # Periodically tidy up and do incremental sync
76 while :
77 do
78 # start timer
79 start_time=`date +%s`
80  
81 # sort
82 tidyup $1 || error "Sort failed, please send logfile.txt to toxygen1@gmail.com"
83  
84 # increase counter every hour
85 # if 24 hour mark is hit, do daily sync
86 if [[ "$HOURCOUNT" -eq 24 ]]
87 then
88 info "Doing complete sync"
89 syncdir .
90 HOURCOUNT=0
91 fi
92  
93 if [ -f "$1"/LAST ]
94 then
95 # next line is important for the first run of the loop
96 read LAST < "$1"/LAST
97  
98 let HOURCOUNT++
99  
100 # read last processed day
101 OLD="$LAST"
102 read LAST < "$1"/LAST
103  
104 # sync last updated folders
105 syncdir ./audio/"$LAST"
106 syncdir ./capture/"$LAST"
107 syncdir ./data/"$LAST"
108  
109 # days changed, sync yesterday too
110 [[ "$LAST" != "$OLD" ]] && info "syncing yesterday" && syncdir "$OLD"
111  
112 tail -n 1000 "$1"/logfile.txt > "$1"/tmp.txt
113 mv "$1"/tmp.txt "$1"/logfile.txt
114 fi
115  
116 # end timer
117 end_time=`date +%s`
118 ELAPSED=`expr $end_time - $start_time`
119 info "execution time was $ELAPSED s"
3410 kakl 120  
121 date
122  
3407 kakl 123 # if last sync took less than TIME, sleep to make up 1 hour
3410 kakl 124 # [[ $ELAPSED -lt $FREQUENCY ]] && sleep `expr $FREQUENCY - $ELAPSED`
125 sleep $FREQUENCY
3407 kakl 126 done